> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://mezmo.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://mezmo.ferndocs.com/_mcp/server.

# Initialize a pipeline with provided components. All sources, transforms, and sinks are linked.

POST https://api.mezmo.com/v3/pipeline/with-components
Content-Type: application/json

Populates and publishes a new pipeline as specified.

Reference: https://mezmo.ferndocs.com/api-reference/pipeline/pipelines/initialize-a-pipeline-with-provided-components-all-sources-transforms-and-sinks-are-linked

## Authentication

- `Authorization` header (required) (prefixed with ` Token  `) — Header authentication of the form `Token <token>`

## Request

### Body (application/json)

This endpoint expects an object.

- `sources` (list of PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaSourcesItems, required)
- `transforms` (list of PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaTransformsItems, required)
- `sinks` (list of PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaSinksItems, required)
- `origin` (enum, optional, default: system)
  - Allowed values: `ui`, `system`
- `pipeline` (PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaPipeline, optional, nullable)

## Response

### 200

Default Response

## Types

### PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaSourcesItems

- `user_config` (PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaSourcesItemsUserConfig, required)
- `title` (string, optional, nullable)
- `description` (string, optional, nullable)
- `type` (enum, optional)
  - Allowed values: `http`, `splunk-hec`, `s3`, `sqs`, `demo-logs`, `kinesis-firehose`, `fluent`, `log-analysis`, `log-analysis-ingestion`, `logstash`, `mezmo-agent`, `mezmo-datadog-source`, `pipeline-data-restoration`, `webhook`, `kafka`, `azure-event-hub`, `prometheus-remote-write`, `open-telemetry-metrics`, `open-telemetry-logs`, `open-telemetry-traces`

### PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaTransformsItems

- `user_config` (PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaTransformsItemsUserConfig, required)
- `title` (string, optional, nullable)
- `description` (string, optional, nullable)
- `type` (enum, optional)
  - Allowed values: `filter`, `sample`, `drop-fields`, `parse`, `parse-sequentially`, `route`, `stringify`, `compact-fields`, `flatten-fields`, `dedupe`, `encrypt-fields`, `decrypt-fields`, `js-script`, `unroll`, `vrl`, `reduce`, `map-fields`, `metrics-tag-cardinality-limit`, `aggregate`, `event-to-metric`, `clustering`, `redact`, `throttle`, `set-timestamp`, `data-profiler`, `replace`, `trace-sampling`

### PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaSinksItems

- `user_config` (PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaSinksItemsUserConfig, required)
- `title` (string, optional, nullable)
- `description` (string, optional, nullable)
- `type` (enum, optional)
  - Allowed values: `mezmo`, `mezmo-archive`, `http`, `cloudwatch-logs`, `cloudwatch-metrics`, `sqs`, `notification-channel`, `azure-blob-storage`, `kinesis-firehose`, `kinesis-streams`, `elasticsearch`, `gcp-cloud-monitoring`, `gcp-cloud-storage`, `gcp-cloud-operations`, `gcp-cloud-pubsub`, `honeycomb-logs`, `indexed-search`, `kafka`, `loki`, `new-relic`, `prometheus-remote-write`, `pulsar`, `redis`, `splunk-hec-logs`, `sumo-logic-logs`, `sumo-logic-metrics`, `vector`, `s3`, `blackhole`, `datadog-logs`, `datadog-metrics`, `clickhouse`, `opentelemetry`

### PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaPipeline

- `id` (string, optional)
- `title` (string, optional, nullable)

### PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaSourcesItemsUserConfig

### PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaTransformsItemsUserConfig

### PipelineWithComponentsPostRequestBodyContentApplicationJsonSchemaSinksItemsUserConfig

## Examples

**Request**

```json
{
  "sources": [
    {
      "user_config": {}
    }
  ],
  "transforms": [
    {
      "user_config": {}
    }
  ],
  "sinks": [
    {
      "user_config": {}
    }
  ]
}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://api.mezmo.com/v3/pipeline/with-components"

payload = {
    "sources": [{ "user_config": {} }],
    "transforms": [{ "user_config": {} }],
    "sinks": [{ "user_config": {} }]
}
headers = {
    "Authorization": "Token <pipeline-service-key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.mezmo.com/v3/pipeline/with-components';
const options = {
  method: 'POST',
  headers: {
    Authorization: 'Token <pipeline-service-key>',
    'Content-Type': 'application/json'
  },
  body: '{"sources":[{"user_config":{}}],"transforms":[{"user_config":{}}],"sinks":[{"user_config":{}}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.mezmo.com/v3/pipeline/with-components"

	payload := strings.NewReader("{\n  \"sources\": [\n    {\n      \"user_config\": {}\n    }\n  ],\n  \"transforms\": [\n    {\n      \"user_config\": {}\n    }\n  ],\n  \"sinks\": [\n    {\n      \"user_config\": {}\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Token <pipeline-service-key>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.mezmo.com/v3/pipeline/with-components")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Token <pipeline-service-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"sources\": [\n    {\n      \"user_config\": {}\n    }\n  ],\n  \"transforms\": [\n    {\n      \"user_config\": {}\n    }\n  ],\n  \"sinks\": [\n    {\n      \"user_config\": {}\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.mezmo.com/v3/pipeline/with-components")
  .header("Authorization", "Token <pipeline-service-key>")
  .header("Content-Type", "application/json")
  .body("{\n  \"sources\": [\n    {\n      \"user_config\": {}\n    }\n  ],\n  \"transforms\": [\n    {\n      \"user_config\": {}\n    }\n  ],\n  \"sinks\": [\n    {\n      \"user_config\": {}\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.mezmo.com/v3/pipeline/with-components', [
  'body' => '{
  "sources": [
    {
      "user_config": {}
    }
  ],
  "transforms": [
    {
      "user_config": {}
    }
  ],
  "sinks": [
    {
      "user_config": {}
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Token <pipeline-service-key>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.mezmo.com/v3/pipeline/with-components");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Token <pipeline-service-key>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"sources\": [\n    {\n      \"user_config\": {}\n    }\n  ],\n  \"transforms\": [\n    {\n      \"user_config\": {}\n    }\n  ],\n  \"sinks\": [\n    {\n      \"user_config\": {}\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Token <pipeline-service-key>",
  "Content-Type": "application/json"
]
let parameters = [
  "sources": [["user_config": []]],
  "transforms": [["user_config": []]],
  "sinks": [["user_config": []]]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.mezmo.com/v3/pipeline/with-components")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```